/*
 * AgentBenchmark.cpp
 *
 *  Created on: Apr 6, 2013
 *      Author: ondro
 */

#include "AgentBenchmark.h"

void AgentBenchmark::init(string args){
            trigger_attach("IMAGES_RETRIEVED_int", TRIGGER_MATCHING);
            termination_dflt = AGENTSPACE_RUNNING;
            num_images_dflt = -1;
            time(&start);
            FILE_LOG(logDEBUG) << "BenchmarkAgent Initialized";
        }
void AgentBenchmark::sense_select_act(int pid){
           syn.lock();
           termination = space_read("termination", termination_dflt);
           num_images = space_read("IMAGES_RETRIEVED_int", num_images_dflt);
           syn.unlock();

           if (termination == AGENTSPACE_TERMINATED){
               kill();
               FILE_LOG(logDEBUG) << "Agent " << tid() << " killed.";
           }
           time(&end);
           elapsed_time = difftime(end, start);
           fps = num_images/elapsed_time;

           syn.lock();
           space_write("FPS_double", fps, 2000);
           syn.unlock();
           //FILE_LOG(logDEBUG) << "FPS = " << fps;
       }
AgentBenchmark::AgentBenchmark(string args) : Agent(args){name = "AgentBenchmark";}
AgentBenchmark::AgentBenchmark(Config& cfg) : Agent(cfg){name = "AgentBenchmark";}
AgentBenchmark::~AgentBenchmark(){}
