/*
 * AgentWrite.cpp
 *
 *  Created on: Apr 5, 2013
 *      Author: ondro
 */

#include "AgentCameraRead.h"
using namespace cv;

void AgentCameraRead::init(string args) {
	termination_dflt = AGENTSPACE_RUNNING;
	// Initialization of camera, primary camera is from /dev/video1
	cap.open(DEFAULT_CAPTURE_DEVICE_1);
	endOfCapture = FALSE;
	if (!cap.isOpened()){
		FILE_LOG(logERROR) << "Open of capture device failed!";
		cap.open(DEFAULT_CAPTURE_DEVICE_0);
		//termination_dflt = AGENTSPACE_TERMINATED;
		if (!cap.isOpened()){
			endOfCapture = TRUE;
		}
	}
	else{
		FILE_LOG(logDEBUG) << "Capture device successfully opened!";
		cap.set(CV_CAP_PROP_FRAME_WIDTH, width);
		cap.set(CV_CAP_PROP_FRAME_HEIGHT, height);
	}
	i = 0;
	timer_attach(1000, 1000 / 15);
	num_images = 0;
}

void AgentCameraRead::sense_select_act(int pid) {
	FILE_LOG(logDEBUG4) << "begin of sense_select_act WriteAgent";
	syn.lock();
	// block "termination" is used for propagation signal for end of agentspace (because of user termination or critical error)
	termination = space_read("termination", termination_dflt);
	syn.unlock();

	//This is unsychronized operation !!!
	//syn.lock();
	if (!endOfCapture) {
		cap >> image;
		num_images++;
	}
	image_write = image.clone();
	//syn.unlock();

	syn.lock();
	if (image.rows > 0 && image.cols > 0) {
		cv::Size size = image_write.size();
		space_write("IMAGE_SIZE_Size", size, 5000);
		space_write("INPUT_Mat", image_write, 5000);
		space_write("IMAGES_RETRIEVED_int", num_images, 1000);
	}
	syn.unlock();

	if (termination == AGENTSPACE_TERMINATED) {
		endOfCapture = TRUE;
		cap.release();
		kill();
	}
}

AgentCameraRead::AgentCameraRead(string args) : Agent(args) {
	//cfg.width = DEFAULT_WIDTH;
	//cfg.height = DEFAULT_HEIGHT;
	name = "AgentCameraRead";
}

AgentCameraRead::AgentCameraRead(Config& cfg) : Agent(cfg) {
	width = cfg.width;
	height = cfg.height;
	name = "AgentCameraRead";
}

AgentCameraRead::~AgentCameraRead() {
}


