/*
 * AgentCorrection.cpp
 *
 *  Created on: Apr 28, 2013
 *      Author: ondro
 */

#include "AgentCorrection.h"
using namespace cv;

void AgentCorrection::init (string args) {
	debug_level = logDEBUG;
	correction_dflt = false;
	termination_dflt = AGENTSPACE_RUNNING;
	agent_activity_dflt = ACTIVITY::PASSIVE;
	timer_attach(1000, 100);
}
void AgentCorrection::sense_select_act (int pid) {
	syn.lock();
	termination = space_read("termination", termination_dflt);
	correction = space_read("POSITION_CORRECTION_bool", correction_dflt);
	agent_activity = space_read("AGENT_CORRECTION_ACTIVITY", agent_activity_dflt);
	syn.unlock();

	ACTIVITY::e agent_next_activity = ACTIVITY::PASSIVE;
	bool wake_direction_finder = false;
	if (correction){
		FILE_LOG(debug_level) << "AgentCorrection";
		agent_next_activity = ACTIVITY::ACTIVE;
	}
	if (agent_activity == ACTIVITY::ACTIVE && correction == false){
		wake_direction_finder = true;
		agent_next_activity = ACTIVITY::PASSIVE;
	}

	syn.lock();
	space_write("AGENT_CORRECTION_ACTIVITY", agent_next_activity);
	if (wake_direction_finder){
		FILE_LOG(debug_level) << "Agent Correction: waking Agent DirectionFinder";
		ACTIVITY::e agent_direction_finder_active = ACTIVITY::ACTIVE;
		space_write("AGENT_DIRECTION_FINDER_ACTIVITY", agent_direction_finder_active, 0, 2);
	}
	syn.unlock();


	if (termination == AGENTSPACE_TERMINATED){
		kill();
	}
}

AgentCorrection::AgentCorrection (string args) : Agent(args) {
	name = "AgentCorrection";
};
AgentCorrection::AgentCorrection (Config& cfg) : Agent(cfg){
	name = "AgentCorrection";
}
AgentCorrection::~AgentCorrection(){};


