/*age
 * AgentGUI.cpp
 *
 *  Created on: Apr 6, 2013
 *      Author: ondro
 */

#include "AgentGUI.h"
using namespace cv;

void AgentGUI::init (string args) {
	block_name1 = "Vanishing_Mat";
	block_name2 = "REFERENCE_IMAGE_Mat";
	//block_name3 = "IMG_CANNY";
	block_name3 = "MATCHED_Mat";


	namedWindow(block_name1);
	namedWindow(block_name2);
	namedWindow(block_name3);
	//namedWindow("Vanishing_Mat");
	namedWindow("GUIControl");
	moveWindow(block_name1, 0, 0);
	moveWindow(block_name2, cfg.width, 0);
	moveWindow(block_name3, 0, cfg.height);
	//moveWindow("Vanishing_Mat", 640, 640);
	moveWindow("GUIControl", 0, cfg.height);
	minThreshold = 30;
	max_minThreshold = 255;
	maxThreshold = 90;
	max_maxThreshold = 255;
	fps_dflt = -1;
	//cvCreateButton("Button1", callBackButton, NULL, CV_CHECKBOX, 0);
	createTrackbar("MinThreshold:", "GUIControl", &minThreshold, max_minThreshold);
	createTrackbar("MaxThreshold:", "GUIControl", &maxThreshold, max_maxThreshold);
	//cvCreateButton("Button2", callBackButton, NULL, CV_CHECKBOX, 0);
	GUIBackground = Mat(100, 200, CV_8UC3, Scalar(0, 0, 0));

	//imshow("GUIControl", Mat(100, 200, CV_8UC1, Scalar(255, 255, 255)));
	timer_attach(500,1000/10);
	endOfCapture = FALSE;
	image_dflt = imread("lena.jpg");
	//termination = AGENTSPACE_RUNNING;
	termination_dflt = AGENTSPACE_RUNNING;

}

void AgentGUI::sense_select_act (int pid) {
	FILE_LOG(logDEBUG1) << "begin ssa 2. agent";
	syn.lock();
	termination = space_read<int>("termination", termination_dflt);
	fps = space_read("FPS_double", fps_dflt);
	// Vanishing Point
	image1 = space_read(block_name1, image_dflt);
	image2 = space_read(block_name2, image_dflt);
	image3 = space_read(block_name3, image_dflt);
	image1 = image1.clone();
	image2 = image2.clone();
	image3 = image3.clone();
	syn.unlock();

	ostringstream ostr;
	GUIBackground = Mat(100, 200, CV_8UC3, Scalar(0, 0, 0));
	ostr << "FPS: " << fps;
	fps_string = ostr.str();

	if (!endOfCapture){
		imshow(block_name1, image1);
		imshow(block_name2, image2);
		imshow(block_name3, image3);
		Point org(20, 20);
		putText( GUIBackground, fps_string, org, CV_FONT_HERSHEY_COMPLEX_SMALL, 0.75, Scalar(255, 255, 255), 1, 3 );
		imshow("GUIControl", GUIBackground);
		//imshow("Vanishing_Mat", image3);
	}

	syn.lock();
	//Trackbar constants
	space_write("Trackbar_lowThreshold_int", minThreshold, 2000);
	space_write("Trackbar_maxThreshold_int", maxThreshold, 2000);
	syn.unlock();

	if (termination == AGENTSPACE_TERMINATED || waitKey(1) == 27){
		termination = AGENTSPACE_TERMINATED;
		syn.lock();
		space_write("termination", termination, 5000);
		syn.unlock();
		endOfCapture = TRUE;
		destroyAllWindows();
		kill();
		//FILE_LOG(logDEBUG) << "Agent " << tid() << " killed";
	}
}

AgentGUI::AgentGUI (string args) : Agent(args) {
	//FILE_LOG(logDEBUG) << "GUI Agent created id = " << tid();
	name = "AgentGUI";
}

AgentGUI::AgentGUI (Config& cfg) : Agent(cfg) {
	//FILE_LOG(logDEBUG) << "GUI Agent created id = " << tid();
	name = "AgentGUI";
}
AgentGUI::~AgentGUI(){}


