/*
 * AgentGUI.h
 *
 *  Created on: Apr 6, 2013
 *      Author: ondro
 */

#ifndef AGENTGUI_H_
#define AGENTGUI_H_
#include "agents.h"
#include "opencv2/core/core.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"

class AgentGUI : public Agent {
    private:
        int i;
        int termination;
        int termination_dflt;
        bool endOfCapture;
        cv::Mat image1;
        cv::Mat image2;
        cv::Mat image3;
        cv::Mat image_dflt;
        cv::Mat GUIBackground;
        int minThreshold;
        int max_minThreshold;
        int maxThreshold;
        int max_maxThreshold;
        double fps;
        string fps_string;
        double fps_dflt;

        string block_name1;
        string block_name2;
        string block_name3;
    protected:
        void init (string args);
        void sense_select_act (int pid);
    public:
        AgentGUI (string args);
        AgentGUI (Config& cfg);
        ~AgentGUI();
};


#endif /* AGENTGUI_H_ */
