/*
 * AgentHistogram.cpp
 *
 *  Created on: Apr 21, 2013
 *      Author: ondro
 */

#include "AgentHistogram.h"
using namespace cv;

Histogram1D::Histogram1D(){
	histSize[0] = 256;
	hranges[0] = 0.0;
	hranges[1] = 255.0;
	ranges[0] = hranges;
	channels[0] = 0;
}
cv::MatND Histogram1D::getHistogram(const cv::Mat& image){
	cv::MatND hist;
	cv::calcHist(&image, 1, channels, cv::Mat(), hist, 1, histSize, ranges);
	return hist;
}


void AgentHistogram::init(string args){
	termination_dflt = AGENTSPACE_RUNNING;
	image_dflt = imread("lena.jpg");
	timer_attach(1000, 100);
}

void AgentHistogram::sense_select_act(int pid){
	syn.lock();
	image = space_read("Work2_Mat", image_dflt);
	termination = space_read("termination", termination_dflt);
	//image = image_dflt;
	image = image.clone();
	syn.unlock();


	cvtColor(image, image, CV_RGB2GRAY);
	MatND histo = h.getHistogram(image);
	FILE_LOG(logDEBUG) << "Histogram retrieved";
	/*
           for(int i = 0; i < 256; i++){
               FILE_LOG(logDEBUG) << "Value " << i << " = " << histo.at<float>(i);
           }
	 */
	double maxVal = 0;
	double minVal = 0;
	int hist_h = 256;
	int hist_w = 256;
	minMaxLoc(histo, &minVal, &maxVal, 0, 0);
	histImg = Mat(hist_h, hist_w, CV_8U, Scalar(255));
	int hpt = static_cast<int>(0.9 * hist_h);
	for(int i = 0; i < hist_w; i++){
		float binVal = histo.at<float>(i);
		int intensity = static_cast<int>(binVal * hpt / maxVal);
		line(histImg, Point(i, hist_h), Point(i, hist_h - intensity), Scalar::all(0));
	}
	syn.lock();
	space_write("HISTOGRAM_Mat", histImg, 2000);
	syn.unlock();
	if (termination == AGENTSPACE_TERMINATED){
		kill();
	}
}

AgentHistogram::AgentHistogram (string args) : Agent(args) {
	name = "AgentHistogram";
};
AgentHistogram::AgentHistogram (Config& cfg) : Agent(cfg){
	name = "AgentHistogram";
}
AgentHistogram::~AgentHistogram(){};




