/*
 * AgentLaplacian.cpp
 *
 *  Created on: Apr 7, 2013
 *      Author: ondro
 */

#include "AgentLaplacian.h"


using namespace cv;

void AgentLaplacian::init (string args) {
	kernel_size = 3;
	scale = 1;
	delta = 0;
	ddepth = CV_16S;

	trigger_attach("Work3_Mat", TRIGGER_MATCHING);
	image_dflt = imread("lena.jpg");
	termination_dflt = AGENTSPACE_RUNNING;
}
void AgentLaplacian::sense_select_act (int pid) {
	syn.lock();
	termination = space_read("termination", termination_dflt);
	syn.unlock();
	if (termination == AGENTSPACE_TERMINATED){
		kill();
		//FILE_LOG(logDEBUG) << "Agent " << tid() << " killed.";
	}
	syn.lock();
	image_input = space_read("Work3_Mat", image_dflt);
	syn.unlock();
	image_input = image_input.clone();
	// Remove noise by blurring with a Gaussian filter
	GaussianBlur( image_input, image_input, Size(kernel_size,kernel_size), 0, 0, BORDER_DEFAULT );

	Mat image_gray;
	cvtColor(image_input, image_gray, CV_BGR2GRAY);

	Mat dst;
	Mat image_laplacian;
	Laplacian( image_gray, dst, ddepth, kernel_size, scale, delta, BORDER_DEFAULT );

	convertScaleAbs( dst, image_laplacian );
	//image_laplacian = image_gray - image_laplacian;
	//convertScaleAbs( image_laplacian, image_laplacian );

	syn.lock();
	space_write("INPUT_GRAY_Mat", image_gray, 2000);
	space_write("INPUT_LAPLACIAN_Mat", image_laplacian, 2000);
	syn.unlock();
}

AgentLaplacian::AgentLaplacian (string args) : Agent(args) {
	name = "AgentLaplacian";
};
AgentLaplacian::AgentLaplacian (Config& cfg) : Agent(cfg){
	name = "AgentLaplacian";
}
AgentLaplacian::~AgentLaplacian(){};
