/*
 * AgentLaplacian.h
 *
 *  Created on: Apr 7, 2013
 *      Author: ondro
 */

#ifndef AGENTLAPLACIAN_H_
#define AGENTLAPLACIAN_H_
#include "agents.h"


class AgentLaplacian : public Agent {
private:
	int i;
	int termination;
	int termination_dflt;
	cv::Mat image_input;
	cv::Mat image_dflt;

	// Laplacian parameters
	int kernel_size;
	int scale;
	int delta;
	int ddepth;
protected:
	void init (string args);
	void sense_select_act (int pid);
public:
	AgentLaplacian (string args);
	AgentLaplacian (Config& cfg);
	~AgentLaplacian();
};
#endif /* AGENTLAPLACIAN_H_ */
