/*
 * AgentLineSegments.cpp
 *
 *  Created on: Apr 23, 2013
 *      Author: ondro
 */

#include "AgentLineSegments.h"
using namespace cv;

void AgentLineSegments::init(string args){
	debug_level = logDEBUG;
	termination_dflt = AGENTSPACE_RUNNING;
	image_dflt = imread("lena.jpg");
    // Create and init LSWMS
	//procSize = Size(640, 480);
	procSize = Size(800, 456);
    int R = 3;
    numMaxLSegs = 50;
    verbose = false;
    lswms = LSWMS(procSize, R, numMaxLSegs, verbose);
    //lswms.init(procSize, R, numMaxLSegs, verbose);
	timer_attach(2000, 100);
}

void AgentLineSegments::sense_select_act(int pid){
	syn.lock();
	termination = space_read("termination", termination_dflt);
	image = space_read("Work1_Mat", image_dflt);
	image = image.clone();
	syn.unlock();
	//FILE_LOG(debug_level) << "Tu som";
	cvtColor(image, image, CV_BGR2GRAY);
	lswms.run(image, lSegs, errors);
	//FILE_LOG(debug_level) << "Tu som";


	//cv::Scalar mean, stddev;
	//cv::meanStdDev(errors, mean, stddev);
    //lswms.drawLSegs(outputImg, lSegs,CV_RGB(255,0,0), 2);                 // drawing all line segments the same
    //lswms.drawLSegs(image, lSegs, errors);                              // drawing according to errors
    lswms.drawLSegs(image, lSegs,CV_RGB(255,0,0), 2);

    syn.lock();
    space_write("LineSegments_Mat", image, 1000);
    space_write("lSegs", lSegs, 1000);
    syn.unlock();


	if (termination == AGENTSPACE_TERMINATED){
		kill();
	}
}

AgentLineSegments::AgentLineSegments(string args) : Agent(args){
	cfg.width = DEFAULT_WIDTH;
	cfg.height = DEFAULT_HEIGHT;
	name = "AgentLineSegments";
}

AgentLineSegments::AgentLineSegments(Config& cfg) : Agent(cfg){
	name = "AgentLineSegments";
}


AgentLineSegments::~AgentLineSegments() {
	// TODO Auto-generated destructor stub
}

