/*
 * AgentMatcher.h
 *
 *  Created on: Apr 26, 2013
 *      Author: ondro
 */

#ifndef AGENTMATCHER_H_
#define AGENTMATCHER_H_

#include "agents.h"
#include "opencv2/features2d/features2d.hpp"
#include "opencv2/nonfree/features2d.hpp"
#include "opencv2/calib3d/calib3d.hpp"

class AgentMatcher : public Agent {
private:
	int i;
	int termination;
	bool endOfCapture;
	int terminaton;
	int termination_dflt;
	cv::Mat image_reference;
	cv::Mat image_reference_dflt;
	cv::Mat image;
	cv::Mat image_dflt;
	cv::Mat img_matches;
	cv::Mat img_write;
	TLogLevel debug_level;
	cv::Point2f vp;
	cv::Point2f vp_dflt;
	bool correct_vp;
	bool correct_vp_dflt;
	ACTIVITY::e activity;
	ACTIVITY::e activity_dflt;
	vector<cv::Point2f> scene_corners;
	// command for chassis
	string command_left;
	string command_right;
	// phase of agent
	PHASE::e agent_phase;
	PHASE::e agent_phase_dflt;
	// direction to which is robot turning, if correction was initialized.
	MOVEMENT::e agent_next_movement;
	// validity of correction movement
	int correction_time;



protected:
	void init (string args);
	void sense_select_act (int pid);
	void match(cv::Mat& img1, cv::Mat& img2, cv::Mat& img_matches, vector<cv::Point2f>& scene_corners);
public:
	AgentMatcher (string args);
	AgentMatcher (Config& cfg);
	~AgentMatcher();
};




#endif /* AGENTMATCHER_H_ */
