/*
 * AgentObstacle.cpp
 *
 *  Created on: Apr 5, 2013
 *      Author: ondro
 */
//#include "agents.h"
#include "AgentObstacle.h"


void AgentObstacle::init(string args){
	debug_level = logDEBUG2;
	termination_dflt = AGENTSPACE_RUNNING;

	pid1 = timer_attach(1000,50);
	command_left = STEER_LEFT_BACKWARD_RIGHT_FORWARD;
	command_right = STEER_LEFT_FORWARD_RIGHT_BACKWARD;
	command_forward = STEER_BOTH_FORWARD;
	//obstacle_position_dflt = OBSTACLE::NONE;
	obstacle_position_dflt = OBSTACLE::LEFT;
	agent_phase_dflt = PHASE::P0;
	agent_movement_dflt = MOVEMENT::NONE;
	/*
	time1 = 3000;
	time2 = 5000;
	time3 = 10000;
	*/
	time1 = 1000;
	time2 = 2000;
	time3 = 3000;
}

void AgentObstacle::sense_select_act(int pid){
	syn.lock();
	termination = space_read("termination", termination_dflt);
	obstacle_position = space_read("OBSTACLE_POSITION_INT", obstacle_position_dflt);
	agent_phase = space_read("OBSTACLE_AGENT_PHASE_INT", agent_phase_dflt);
	agent_movement = space_read("OBSTACLE_AGENT_MOVEMENT_INT", agent_movement_dflt);
	syn.unlock();

	//FILE_LOG(debug_level) << "__agent_movememnt_dflt = " << agent_movement_dflt;
	//FILE_LOG(debug_level) << "__agent_movememnt = " << agent_movement;

	switch(agent_phase){
	case PHASE::P0:
		FILE_LOG(debug_level) << "PHASE P0 STILL";
		if (obstacle_position == OBSTACLE::LEFT){

			OBSTACLE::e value = OBSTACLE::NOTICED_LEFT;
			PHASE::e phase = PHASE::P1;
			MOVEMENT::e movement = MOVEMENT::RIGHT;
			syn.lock();
			space_write("OBSTACLE_NOTICED_LEFT_INT", value, time3);
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time3);
			space_write("CHASSIS_COMMAND_STRING", command_right, time1, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time1);
			syn.unlock();
		}
		break;
	case PHASE::P1:
		FILE_LOG(debug_level) << "__PHASE P1 TURNING RIGHT";
		if (agent_movement == MOVEMENT::RIGHT){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished turning
			PHASE::e phase = PHASE::P2;
			MOVEMENT::e movement = MOVEMENT::FORWARD;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time3);
			space_write("CHASSIS_COMMAND_STRING", command_forward, time2, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time2);
			syn.unlock();
		}
		break;
	case PHASE::P2:
		FILE_LOG(debug_level) << "PHASE P2 FORWARD";
		if (agent_movement == MOVEMENT::FORWARD){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished forward movement
			PHASE::e phase = PHASE::P3;
			MOVEMENT::e movement = MOVEMENT::LEFT;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time3);
			space_write("CHASSIS_COMMAND_STRING", command_left, time1, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time1);
			syn.unlock();
		}
		break;
	case PHASE::P3:
		FILE_LOG(debug_level) << "PHASE P3 TURNING LEFT";
		if (agent_movement == MOVEMENT::LEFT){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished turning
			PHASE::e phase = PHASE::P4;
			MOVEMENT::e movement = MOVEMENT::FORWARD;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time3);
			space_write("CHASSIS_COMMAND_STRING", command_forward, time2, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time2);
			syn.unlock();
		}
		break;
	case PHASE::P4:
		FILE_LOG(debug_level) << "PHASE P4 FORWARD";
		if (agent_movement == MOVEMENT::FORWARD){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished movement forward
			PHASE::e phase = PHASE::P5;
			MOVEMENT::e movement = MOVEMENT::LEFT;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time3);
			space_write("CHASSIS_COMMAND_STRING", command_left, time1, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time1);
			syn.unlock();
		}
		break;
	case PHASE::P5:
		FILE_LOG(debug_level) << "PHASE P5 TURNING LEFT";
		if (agent_movement == MOVEMENT::LEFT){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished turning
			PHASE::e phase = PHASE::P6;
			MOVEMENT::e movement = MOVEMENT::FORWARD;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time3);
			space_write("CHASSIS_COMMAND_STRING", command_forward, time2, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time2);
			syn.unlock();
		}
		break;
	case PHASE::P6:
		FILE_LOG(debug_level) << "PHASE P6 FORWARD";
		if (agent_movement == MOVEMENT::FORWARD){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished turning
			PHASE::e phase = PHASE::P7;
			MOVEMENT::e movement = MOVEMENT::RIGHT;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time1);
			space_write("CHASSIS_COMMAND_STRING", command_right, time1, 3);
			space_write("OBSTACLE_AGENT_MOVEMENT_INT", movement, time1);
			syn.unlock();
		}
		break;
	case PHASE::P7:
		FILE_LOG(debug_level) << "PHASE P7 TURNING RIGHT";
		if (agent_movement == MOVEMENT::RIGHT){
			// do nothing
		}
		if (agent_movement == MOVEMENT::NONE){
			// finished turning
			PHASE::e phase = PHASE::P0;
			//MOVEMENT::e movement = MOVEMENT::TURNING_RIGHT;
			syn.lock();
			space_write("OBSTACLE_AGENT_PHASE_INT", phase, time1);
			//space_write("CHASSIS_COMMAND_STRING", command_right, time1, 3);
			//space_write("OBSTALE_AGENT_MOVEMENT_INT", movement, time1);
			syn.unlock();
		}
		break;
	default :
		break;
	}
	if (obstacle_position == OBSTACLE::NONE){
		FILE_LOG(logDEBUG) << "No Obstacle";
	}








	/*
	syn.lock();
	space_write("CHASSIS_COMMAND_STRING", command, 2500, 2);
	syn.unlock();
	FILE_LOG(logDEBUG2) << "Command to Chassis has been sent! ";
	 */


	syn.lock();

	if (termination == AGENTSPACE_TERMINATED){
		kill();
		//FILE_LOG(logDEBUG) << "Agent " << tid() << " killed.";
	}
	syn.unlock();
}
AgentObstacle::AgentObstacle(string args) : Agent(args){
	name = "AgentObstacle";
}
AgentObstacle::AgentObstacle(Config&cfg) : Agent(cfg){
	name = "AgentObstacle";
}
AgentObstacle::~AgentObstacle(){
}




