/*
 * AgentPNGWrite.cpp
 *
 *  Created on: Apr 5, 2013
 *      Author: ondro
 */

#include "AgentPNGWrite.h"
using namespace cv;

void AgentPNGWrite::init(string args) {
	debug_level = logDEBUG2;
	frameCount = 0;
	termination_dflt = AGENTSPACE_RUNNING;
	image_dflt = imread("lena.jpg");
	block_write = cfg.block_write;
	//trigger_attach("Work3_Mat", TRIGGER_MATCHING);
	trigger_attach(block_write, TRIGGER_MATCHING);
	//timer_attach(100, 100);
}

void AgentPNGWrite::sense_select_act(int pid) {
	syn.lock();
	// block "termination" is used for propagation signal for end of agentspace (because of user termination or critical error)
	termination = space_read("termination", termination_dflt);
	image = space_read(block_write, image_dflt);
	image_write = image.clone();
	syn.unlock();

	ostringstream ostream;
	//FILE_LOG(debug_level) << "###################################################";
	ostream << DEFAULT_PNG_FILES_DIR << block_write << setfill('0') << setw(4) << frameCount << ".png";
	string name;
	name = ostream.str();
	FILE_LOG(debug_level) << name;
	try {
		imwrite(name, image);
	}
	catch (exception& ex) {
		fprintf(stderr, "Exception converting image to PNG format: %s\n", ex.what());
	}
	FILE_LOG(logDEBUG4) << "end of sense_select_act WriteAgent";
	frameCount++;

	if (termination == AGENTSPACE_TERMINATED) {
		kill();
		//FILE_LOG(logDEBUG) << "Agent " << tid() << " killed";
	}
}

AgentPNGWrite::AgentPNGWrite(string args) : Agent(args) {
	cfg.width = DEFAULT_WIDTH;
	cfg.height = DEFAULT_HEIGHT;
	name = "AgentPNGWrite";
}

AgentPNGWrite::AgentPNGWrite(Config& cfg) : Agent(cfg) {
	name = "AgentPNGWrite";
}

AgentPNGWrite::~AgentPNGWrite() {
}



