/*
 * AgentReferenceImageSaver.cpp
 *
 *  Created on: Apr 26, 2013
 *      Author: ondro
 */

#include "AgentReferenceImageSaver.h"
using namespace cv;

void AgentReferenceImageSaver::init (string args) {
	debug_level = logDEBUG;
	image_dflt = imread("lena.jpg");
	correct_vp_dflt = false;
	reference_image_once_dflt = false;
	save_image_dflt = true;
	termination_dflt = AGENTSPACE_RUNNING;
	trigger_attach("REFERENCE_IMAGE_ONCE_bool", TRIGGER_MATCHING);
	trigger_attach("CORRECT_VP_bool", TRIGGER_MATCHING);
	trigger_attach("SAVE_IMAGE_bool", TRIGGER_MATCHING);
}
void AgentReferenceImageSaver::sense_select_act (int pid) {
	syn.lock();
	termination = space_read("termination", termination_dflt);
	reference_image_once = space_read("REFERENCE_IMAGE_ONCE_bool", reference_image_once_dflt);
	correct_vp = space_read("CORRECT_VP_bool", correct_vp_dflt);
	save_image = space_read("SAVE_IMAGE_bool", save_image_dflt);

	image = space_read("INPUT_Mat", image_dflt);
	image1 = image.clone();
	syn.unlock();

	FILE_LOG(debug_level) << "ReferenceImageSaver " << correct_vp << " "  << save_image;

	if (reference_image_once){
		syn.lock();
		space_write("REFERENCE_IMAGE_Mat", image1);
		bool send_false = false;
		space_write("REFERENCE_IMAGE_ONCE_bool", send_false);
		syn.unlock();
	}
	else{
		if (correct_vp && save_image){
			syn.lock();
			space_write("REFERENCE_IMAGE_Mat", image1													);
			syn.unlock();
		}
	}

	if (termination == AGENTSPACE_TERMINATED){
		kill();
	}
}

AgentReferenceImageSaver::AgentReferenceImageSaver (string args) : Agent(args) {
	name = "AgentReferenceImageSaver";
};
AgentReferenceImageSaver::AgentReferenceImageSaver (Config& cfg) : Agent(cfg){
	name = "AgentReferenceImageSaver";
}
AgentReferenceImageSaver::~AgentReferenceImageSaver(){};


