/*
 * AgentChassisControl.cpp
 *
 *  Created on: Apr 5, 2013
 *      Author: ondro
 */
#include "AgentSteerControl.h"


AgentSteerControl::AgentSteerControl(string args) : Agent(args){
	cfg.width = DEFAULT_WIDTH;
	cfg.height = DEFAULT_HEIGHT;
	name = "AgentChassisControl";
}

AgentSteerControl::AgentSteerControl(Config& cfg) : Agent(cfg){
	name = "AgentChassisControl";
}


AgentSteerControl::~AgentSteerControl() {
	// TODO Auto-generated destructor stub
	chassis.close_port(fd);
}

void AgentSteerControl::init(string args){
	fd = chassis.open_port("/dev/ttyUSB0");
	if (fd == -1){
		FILE_LOG(logERROR) << "Cannot communicate with Chassis !";
	}
	FILE_LOG(logDEBUG2) << "ChassisControl Agent Initialized";
	FILE_LOG(logDEBUG2) << "File Decriptor = " << fd;
	chassis.sendCommand(fd, STEER_RESET);
	//command_dflt = STEER_BOTH_FORWARD;
	command_dflt = STEER_STOP;
	termination_dflt = AGENTSPACE_RUNNING;
	/*
	usleep(100000);
	//chassis.sendCommand(fd, STEER_LEFT_FORWARD_RIGHT_BACKWARD);
	usleep(100000);
	chassis.sendCommand(fd, STEER_LEFT_BACKWARD_RIGHT_FORWARD);
	usleep(100000);
	chassis.sendCommand(fd, STEER_LEFT_FORWARD_RIGHT_BACKWARD);
	usleep(100000);
	*/

	timer_attach(1000, 10);
}

void AgentSteerControl::sense_select_act(int pid){
	// We need to send command STEER_STOP before any other command.
	FILE_LOG(logDEBUG2) << "ChassisCommand called";
	syn.lock();
	termination = space_read("termination", termination_dflt);
	syn.unlock();
	if (termination == AGENTSPACE_TERMINATED){
		kill();
		chassis.sendCommand(fd, STEER_STOP);
		chassis.close_port(fd);
	}
	else{
		syn.lock();
		command = space_read("CHASSIS_COMMAND_STRING", command_dflt);
		syn.unlock();
		const char* command_const = command.c_str();
		chassis.sendCommand(fd, command_const);
		FILE_LOG(logDEBUG2) << "Command " << command_const << " sent to chassis!";
	}

}
