/*
 * AgentVanishingPoint.h
 *
 *  Created on: Apr 6, 2013
 *      Author: ondro
 */
#ifndef AGENTVANISHINGPOINT_H_
#define AGENTVANISHINGPOINT_H_
#include "agents.h"
#include "VanishingPoint.h"


class AgentVanishingPoint : public Agent{
    private:
        int termination;
        int termination_dflt;
        int minThreshold;
        int minThreshold_dflt;
        int maxThreshold;
        int maxThreshold_dflt;
        string inputBlockName;
        // Images
        int procWidth;
        int procHeight;
        cv::Mat image;
        cv::Mat image_dflt;
        cv::Mat inputImg, imgGRAY;
        cv::Mat outputImg;
        // Vanishing point
        int numVps;
        VanishingPoint vanishingPoint;
        // boundaries for vanishing point
        // written by AgentVanishingPointControl
        float middle_region_left;
        float middle_region_left_dflt;
        float middle_region_right;
        float middle_region_right_dflt;
        float middle_region_height;
        float middle_region_height_dflt;

        //lines segment retrieving
        std::vector<std::vector<std::vector<cv::Point> > > line_segments;
        std::vector<std::vector<std::vector<cv::Point> > > line_segments_dflt;

    protected:
        void init(string args);
        void sense_select_act(int pid);
    public:
        AgentVanishingPoint(string args);
        AgentVanishingPoint(Config cfg);
        ~AgentVanishingPoint();
};



#endif /* AGENTVANISHINGPOINT_H_ */
