/*
 * AgentVanishingPointChecker.cpp
 *
 *  Created on: Apr 24, 2013
 *      Author: ondro
 */


#include "AgentVanishingPointChecker.h"
using namespace cv;

void AgentVanishingPointChecker::init (string args) {
	debug_level = logDEBUG2;
	image_dflt = imread("lena.jpg");
	//vp_dflt = Point(-1, -1);
	correct_vp_dflt = false;
	termination_dflt = AGENTSPACE_RUNNING;
	trigger_attach("CORRECT_VP_bool", TRIGGER_MATCHING);
	//trigger_attach("temp", TRIGGER_MATCHING);
	//syn.lock();
	//syn.unlock();
}
void AgentVanishingPointChecker::sense_select_act (int pid) {
	syn.lock();
	termination = space_read("termination", termination_dflt);
	correct_vp = space_read("CORRECT_VP_bool", correct_vp_dflt);
	syn.unlock();

	FILE_LOG(logDEBUG) << "AgentVanishingPointChecker " << correct_vp;

	if (correct_vp){
		syn.lock();
		bool correct_vp_existed = true;
		space_write("CORRECT_VP_EXISTED_bool", correct_vp_existed, 3000);
		syn.unlock();
	}

	if (termination == AGENTSPACE_TERMINATED){
		kill();
	}
}

AgentVanishingPointChecker::AgentVanishingPointChecker (string args) : Agent(args) {
	name = "AgentVanishingPointChecker";
};
AgentVanishingPointChecker::AgentVanishingPointChecker (Config& cfg) : Agent(cfg){
	name = "AgentVanishingPointChecker";
}
AgentVanishingPointChecker::~AgentVanishingPointChecker(){};
