/*
 * AgentVanishingPointCounter.cpp
 *
 *  Created on: Apr 24, 2013
 *      Author: ondro
 */

#include "AgentVanishingPointCounter.h"
using namespace cv;

void AgentVanishingPointCounter::init (string args) {
	debug_level = logDEBUG;
	image_dflt = imread("lena.jpg");
	//vp_dflt = Point(-1, -1);
	correct_vp_dflt = false;
	termination_dflt = AGENTSPACE_RUNNING;
	timer_attach(3000, 300);
	counter_vp_dflt = -1;
	//trigger_attach("CORRECT_VP_bool", TRIGGER_MATCHING);
}
void AgentVanishingPointCounter::sense_select_act (int pid) {
	syn.lock();
	termination = space_read("termination", termination_dflt);
	correct_vp = space_read("CORRECT_VP_bool", correct_vp_dflt);
	counter_vp = space_read("COUNTER_int", counter_vp_dflt);
	syn.unlock();

	syn.lock();
	if (correct_vp){
		int counter = 10;
		space_write("COUNTER_int", counter, 1000);
	}
	else{
		if (counter_vp > 0){
			int counter = counter_vp - 1;
			space_write("COUNTER_int", counter, 1000);
		}
		else if (counter_vp == 0){
			bool lost_vp = true;
			space_write("LOST_VP_bool", lost_vp, 5000);
			ACTIVITY::e agent_active = ACTIVITY::ACTIVE;
			//ACTIVITY::e agent_passive = ACTIVITY::PASSIVE;
			// We write information about uncorrect VP with higher priority
			bool correct_vp_false = false;
			space_write("AGENT_DIRECTION_FINDER_ACTIVITY", agent_active);
			//space_write("CORRECT_VP_bool", correct_vp_false, 0, 2);
		}
	}
	syn.unlock();

	FILE_LOG(logDEBUG) << "VP Counter = " << counter_vp;

	if (termination == AGENTSPACE_TERMINATED){
		kill();
	}
}

AgentVanishingPointCounter::AgentVanishingPointCounter (string args) : Agent(args) {
	name = "AgentVanishingPointCounter";
};
AgentVanishingPointCounter::AgentVanishingPointCounter (Config& cfg) : Agent(cfg){
	name = "AgentVanishingPointCounter";
}
AgentVanishingPointCounter::~AgentVanishingPointCounter(){};
