/*
 * ChassisControl.h
 *
 *  Created on: Mar 28, 2013
 *      Author: ondro
 */
#ifndef CHASSISCONTROL_H_
#define CHASSISCONTROL_H_

#include <stdio.h>   /* Standard input/output definitions */
#include <string.h>  /* String function definitions */
#include <unistd.h>  /* UNIX standard function definitions */
#include <fcntl.h>   /* File control definitions */
#include <errno.h>   /* Error number definitions */
#include <termios.h> /* POSIX terminal control definitions */
#include <iostream>

using namespace std;

#define DEFAULT_COMMAND_LENGTH 2
#define STEER_RESET "B\x0"
#define STEER_LEFT_FORWARD "C\x1"
#define STEER_LEFT_BACKWARD "C\x2"
#define STEER_STOP "C\x3"
#define STEER_RIGHT_BACKWARD "C\x4"
#define STEER_LEFT_FORWARD_RIGHT_BACKWARD "C\x5"
#define STEER_BOTH_BACKWARD "C\x6"
// "C\x7" is STEER_RIGHT_BACKWARD
#define STEER_RIGHT_FORWARD "C\x8"
#define STEER_BOTH_FORWARD "C\x9"
#define STEER_LEFT_BACKWARD_RIGHT_FORWARD "C\x1A"
// "C\x10" is STEER_STOP as well
// "C\x11" is STEER_LEFT_FORWARD
// "C\x12" is STEER_LEFT_BACKWARD
// "C\x13" is STEER_STOP

//#define STEER_LEFT_BACKWARD_RIGHT_FORWARD "C\x15"

//#define STEER_LEFT_BACKWARD_RIGHT_FORWARD "C\x5"
//#define STEER_RIGHT_FORWARD "C\x6"

//#define STEER_LEFT_FORWARD_RIGHT_BACKWARD "C\x7"
//#define STEER_BOTH_FORWARD "C\x9"
//#define STEER_BOTH_BACKWARD "C\x5"

class ChassisControl {
private:
public:
	int open_port(const char* device);
	void sendCommand(int fd, const char* command, int length = DEFAULT_COMMAND_LENGTH);
	void close_port(int fd);
	ChassisControl();
	~ChassisControl();
};

#endif /* CHASSISCONTROL_H_ */
