/*
 * VanishingPoint.h
 *
 *  Created on: Apr 6, 2013
 *      Author: ondro
 */

#ifndef VANISHINGPOINT_H_
#define VANISHINGPOINT_H_
#include "opencv2/core/core.hpp"
#include "opencv2/highgui/highgui.hpp"
#include "opencv2/imgproc/imgproc.hpp"
#include "log.h"
#include "MSAC.h"
#include "errorNIETO.h"
#include <set>


class VanishingPoint{
    private:
        int minCannyThreshold;
        int maxCannyThreshold;
        cv::Mat imgCanny;
        int mode;
        int numVps;
        bool verbose;
        MSAC msac;
        cv::Size procSize;
        std::vector<std::vector<std::vector<cv::Point> > > lineSegmentsClusters;
    protected:
    public:
        void init(int numVps, int width, int height);
        void setMinThreshold(int minThreshold);
        void setMaxThreshold(int maxThreshold);
        cv::Mat& getimgCanny();
        void getlineSegmentsClusters(std::vector<std::vector<std::vector<cv::Point> > >& );
        void processImage(int numVps, cv::Mat& imgGRAY, cv::Mat& outputImg, vector<cv::Mat>& vps);
        void processImage(MSAC& msac, int numVps, cv::Mat& imgGRAY, cv::Mat& outputImg, vector<cv::Mat>& vps);
        VanishingPoint();
        ~VanishingPoint();
};


#endif /* VANISHINGPOINT_H_ */
